/// <reference types="node" resolution-mode="require"/>
import WebSocket from 'ws';
import type { CommandData } from './remoteTypes.js';
import type { CommandResponse } from './localTypes.js';
import type { ClientRequestArgs } from 'node:http';
export declare class BidiCore {
    #private;
    private _webSocketUrl;
    constructor(_webSocketUrl: string, opts?: WebSocket.ClientOptions | ClientRequestArgs);
    connect(): Promise<void>;
    get socket(): WebSocket;
    get isConnected(): boolean;
    send(params: Omit<CommandData, 'id'>): Promise<CommandResponse>;
    sendAsync(params: Omit<CommandData, 'id'>): number;
}
//# sourceMappingURL=core.d.ts.map